<?php

/**
 * @package LayerSlider WP
 * @version 3.0.2
 */
/*

Plugin Name: LayerSlider WP
Plugin URI: http://codecanyon.net/user/kreatura/
Description: The Wordress Parallax Slider
Version: 3.0.2
Author: Kreatura Media
Author URI: http://kreaturamedia.com/
*/

/********************************************************/
/*                        Actions                       */
/********************************************************/

	// Register custom settings menu
	add_action('admin_menu', 'layerslider_settings_menu');

	// Link content resources
	add_action('wp_enqueue_scripts', 'layerslider_enqueue_content_res');

	// Link admin resources
	add_action('admin_enqueue_scripts', 'layerslider_enqueue_admin_res');

	// Add shortcode
	add_shortcode("layerslider","layerslider_init");

	// Widget action
	add_action( 'widgets_init', create_function( '', 'register_widget("LayerSlider_Widget");' ) );

	// Remove slider
	if(isset($_GET['page']) && $_GET['page'] == 'layerslider' && isset($_GET['action']) && $_GET['action'] == 'remove') {
		layerslider_removeslider( $_GET['id'] );
	}

	// Duplicate slider
	if(isset($_GET['page']) && $_GET['page'] == 'layerslider' && isset($_GET['action']) && $_GET['action'] == 'duplicate') {
		layerslider_duplicateslider( $_GET['id'] );
	}

	// Duplicate slider
	if(isset($_GET['page']) && $_GET['page'] == 'layerslider' && isset($_GET['action']) && $_GET['action'] == 'import_sample') {
		layerslider_import_sample_slider();
	}

	// Help menu
	add_filter('contextual_help', 'layerslider_help', 10, 3);

/********************************************************/
/*               Enqueue Content Scripts                */
/********************************************************/

	function layerslider_enqueue_content_res() {

		wp_enqueue_script('layerslider_js', plugins_url('/js/layerslider.kreaturamedia.jquery.js', __FILE__), array('jquery'), '3.0.2' );
		wp_enqueue_script('jquery_easing', plugins_url('/js/jquery-easing-1.3.js', __FILE__), array('jquery'), '1.3.0' );
		wp_enqueue_style('layerslider_css', plugins_url('/css/layerslider.css', __FILE__), array(), '3.0.2' );
	}


/********************************************************/
/*                Enqueue Admin Scripts                 */
/********************************************************/

	function layerslider_enqueue_admin_res() {

		if(strstr($_SERVER['REQUEST_URI'], 'layerslider')) {

			wp_enqueue_script('thickbox');
			wp_enqueue_style('thickbox');

			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('jquery-ui-draggable');

			wp_enqueue_script('farbtastic');
			wp_enqueue_style('farbtastic');

			wp_enqueue_script('layerslider_admin_js', plugins_url('/js/admin.js', __FILE__), array('jquery'), '3.0.2' );
			wp_enqueue_style('layerslider_admin_js', plugins_url('/css/admin.css', __FILE__), array(), '3.0.2' );

			wp_enqueue_script('layerslider_js', plugins_url('/js/layerslider.kreaturamedia.jquery.js', __FILE__), array('jquery'), '3.0.2' );
			wp_enqueue_script('jquery_easing', plugins_url('/js/jquery-easing-1.3.js', __FILE__), array('jquery'), '1.3.0' );
			wp_enqueue_style('layerslider_css', plugins_url('/css/layerslider.css', __FILE__), array(), '3.0.2' );
		}
	}

function layerslider_help($contextual_help, $screen_id, $screen) {

	global $layerslider_hook;
	if ($screen_id == $layerslider_hook) {
		$screen = get_current_screen();

		if(function_exists('file_get_contents')) {

			// List view
			if(!isset($_GET['action'])) {

				// Overview
				$screen->add_help_tab(array(
				   'id' => 'home_overview',
				   'title' => 'Overview',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/home_overview.html')
				));

				// Managing sliders
				$screen->add_help_tab(array(
				   'id' => 'home_screen',
				   'title' => 'Managing sliders',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/managing_sliders.html')
				));

				// Insert LayerSlider to your page
				$screen->add_help_tab(array(
				   'id' => 'inserting_slider',
				   'title' => 'Insert LayerSlider to your page',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/inserting_slider.html')
				));

				// Export / Import
				$screen->add_help_tab(array(
				   'id' => 'exportimport',
				   'title' => 'Export / Import',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/exportimport.html')
				));

				// Sample slider
				$screen->add_help_tab(array(
				   'id' => 'sample_slider',
				   'title' => 'Sample sliders',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/sample_slider.html')
				));

			// Editor view
			} else {

				// Overview
				$screen->add_help_tab(array(
				   'id' => 'overview',
				   'title' => 'Overview',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/edit_overview.html')
				));

				// Slider types
				$screen->add_help_tab(array(
				   'id' => 'slider_types',
				   'title' => 'Slider types',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/slider_types.html')
				));

				// Layer options
				$screen->add_help_tab(array(
				   'id' => 'layer_options',
				   'title' => 'Layer options',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/layer_options.html')
				));

				// Sublayer options
				$screen->add_help_tab(array(
				   'id' => 'sublayer_options',
				   'title' => 'Sublayer options',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/sublayer_options.html')
				));

				// WYSIWYG Editor
				$screen->add_help_tab(array(
				   'id' => 'wysiwyg_editor',
				   'title' => 'WYSIWYG Editor',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/wysiwyg_editor.html')
				));

				// Embedding videos
				$screen->add_help_tab(array(
				   'id' => 'embedding_videos',
				   'title' => 'Embedding videos',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/embedding_videos.html')
				));

				// Other features
				$screen->add_help_tab(array(
				   'id' => 'other_features',
				   'title' => 'Other features',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/other_features.html')
				));

				// Event callbacks
				$screen->add_help_tab(array(
				   'id' => 'event_callbacks',
				   'title' => 'Event callbacks',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/event_callbacks.html')
				));

				// LayerSlider API
				$screen->add_help_tab(array(
				   'id' => 'layerslider_api',
				   'title' => 'LayerSlider API',
				   'content' => file_get_contents(dirname(__FILE__).'/docs/api.html')
				));
			}
		} else {

			// Error
			$screen->add_help_tab(array(
				'id' => 'error',
				'title' => 'Error',
				'content' => 'This help section couldn\'t show you the documentation because your server don\'t support the "file_get_contents" function'
			));
		}
	}
}

/********************************************************/
/*                 Loads settings menu                  */
/********************************************************/
function layerslider_settings_menu() {

	// Menu hook
	global $layerslider_hook;

	//create new top-level menu
	$layerslider_hook = add_menu_page('LayerSlider WP', 'LayerSlider WP', 'manage_options', 'layerslider', 'layerslider_router');

	//call register settings function
	add_action( 'admin_init', 'layerslider_register_settings' );
}

/********************************************************/
/*                    Settings page                     */
/********************************************************/
function layerslider_router() {

	// Add new
	if(isset($_GET['action']) && $_GET['action'] == 'add') {
		include(dirname(__FILE__).'/add.php');

	// Edit
	} elseif(isset($_GET['action']) && $_GET['action'] == 'edit') {
		include(dirname(__FILE__).'/edit.php');

	// List
	} else {
		include(dirname(__FILE__).'/list.php');
	}
}

/********************************************************/
/*                  Register settings                   */
/********************************************************/
function layerslider_register_settings() {

	// Save settings
	if(isset($_POST['posted']) && strstr($_SERVER['REQUEST_URI'], 'layerslider')) {

		// Get option
		$slides = get_option('layerslider-slides');
		$slides = empty($slides) ? array() : $slides;
		$slides = is_array($slides) ? $slides : unserialize($slides);

		// Empty the slider
		if($_POST['layerkey'] == 0) {
			$slides[ $_POST['sliderkey'] ] = array();
		}

		// Add modifications
		if($_POST['layerslider-slides']['properties']['relativeurls'] == 'true') {
			$slides[ $_POST['sliderkey'] ]['properties'] = $_POST['layerslider-slides']['properties'];
			$slides[ $_POST['sliderkey'] ]['layers'][ $_POST['layerkey'] ] = layerslider_convert_urls($_POST['layerslider-slides']['layers'][$_POST['layerkey']]);
		} else {
			$slides[ $_POST['sliderkey'] ]['properties'] = $_POST['layerslider-slides']['properties'];
			$slides[ $_POST['sliderkey'] ]['layers'][ $_POST['layerkey'] ] = $_POST['layerslider-slides']['layers'][$_POST['layerkey']];
		}

		// Add option if it is not extists yet
		if(get_option('layerslider-slides') === false) {
			add_option('layerslider-slides', serialize($slides));

		// Update option
		} else {
			update_option('layerslider-slides', serialize($slides));
		}

		// Redirect back
		//header('Location: '.$_SERVER['REQUEST_URI'].'');
		die();
	}

	// Import settings
	if(isset($_POST['import']) && strstr($_SERVER['REQUEST_URI'], 'layerslider')) {

		// Get new sliders
		$import = unserialize(base64_decode($_POST['import']));

		// Exit when the unserialization failes
		if(!is_array($import)) {
			header('Location: '.$_SERVER['REQUEST_URI'].'');
			die();
		}

		// Get old sliders
		$slides = get_option('layerslider-slides');
		$slides = empty($slides) ? array() : $slides;
		$slides = is_array($slides) ? $slides : unserialize($slides);

		// Convert URLs
		/*foreach($import as $key => $val) {
			$import[$key] = layerslider_convert_urls($val);
		}*/

		// Unify old and new sliders
		$slides = array_merge($slides, $import);
		$slides = serialize($slides);

		// Add option if it is not extists yet
		if(get_option('layerslider-slides') === false) {
			add_option('layerslider-slides', $slides);

		// Update option
		} else {
			update_option('layerslider-slides', $slides);
		}

		// Redirect back
		header('Location: '.$_SERVER['REQUEST_URI'].'');
		die();
	}
}

/********************************************************/
/*                 LayerSlider init                     */
/********************************************************/

function layerslider_init($atts) {

	// Get slider ID
	$id = $atts['id'];
	$id = empty($id) ? 1 : $id;

	// Get slider data
	$slides = get_option('layerslider-slides');
	$slides = is_array($slides) ? $slides : unserialize($slides);
	$slides = $slides[($id-1)];

	// Include slider file
	include(dirname(__FILE__).'/init.php');
	include(dirname(__FILE__).'/slider.php');

	// Return data
	return $data;
}

/********************************************************/
/*               Action to duplicate slider             */
/********************************************************/
function layerslider_duplicateslider($key) {

	$key = (int) $key;

	// Get sliders
	$slides = get_option('layerslider-slides');
	$slides = is_array($slides) ? $slides : unserialize($slides);

	// Get slider
	$slider = $slides[ $key ];

	// Name check
	if(empty($slider['properties']['title'])) {
		$slider['properties']['title'] = 'Unnamed';
	}

	// Rename
	$slider['properties']['title'] .= ' copy';

	// Append duplicate
	$slides[] = $slider;

	// Update settings
	update_option('layerslider-slides', serialize($slides));

	// Success
	header('Location: admin.php?page=layerslider');
	die();
}


/********************************************************/
/*                Action to remove slider               */
/********************************************************/
function layerslider_removeslider($key) {

	$key = (int) $key;

	// Get option
	$slides = get_option('layerslider-slides');
	$slides = is_array($slides) ? $slides : unserialize($slides);

	// Remove the slider
	array_splice($slides, $key, 1);

	// Update settings
	update_option('layerslider-slides', serialize($slides));

	// Success
	header('Location: admin.php?page=layerslider');
	die();
}

/********************************************************/
/*            Action to import sample slider            */
/********************************************************/
function layerslider_import_sample_slider() {

	// Base64 encoded, serialized slider export code
	$sample_slider = unserialize(base64_decode(file_get_contents(dirname(__FILE__).'/sample_sliders.txt')));

	// Change yourLogo
	$sample_slider[0]['properties']['yourlogo'] = plugins_url('/sampleslider/' . $sample_slider[0]['properties']['yourlogo'], __FILE__);

	// Iterate over the sliders
	foreach($sample_slider as $sliderkey => $slider) {

		// Iterate over the layers
		foreach($sample_slider[$sliderkey]['layers'] as $layerkey => $layer) {

			// Change background images if any
			if(!empty($sample_slider[$sliderkey]['layers'][$layerkey]['properties']['background'])) {
				$sample_slider[$sliderkey]['layers'][$layerkey]['properties']['background'] = plugins_url('/sampleslider/' . $layer['properties']['background'], __FILE__);
			}

			// Iterate over the sublayers
			foreach($layer['sublayers'] as $sublayerkey => $sublayer) {

				// Only IMG sublayers
				if($sublayer['type'] == 'img') {
					$sample_slider[$sliderkey]['layers'][$layerkey]['sublayers'][$sublayerkey]['image'] = plugins_url('/sampleslider/' . $sublayer['image'], __FILE__);
				}
			}
		}
	}

	// Get sliders
	$sliders = get_option('layerslider-slides');
	$sliders = is_array($sliders) ? $sliders : unserialize($sliders);
	$sliders = is_array($sliders) ? $sliders : array();

	// Append duplicate
	foreach($sample_slider as $key => $val) {
		$sliders[] = $sample_slider[$key];
	}

	// Add option if it is not extists yet
	if(get_option('layerslider-slides') === false) {
		add_option('layerslider-slides', $sliders);

	// Update option
	} else {
		update_option('layerslider-slides', $sliders);
	}

	// Success
	header('Location: admin.php?page=layerslider');
	die();
}

/********************************************************/
/*                        MISC                          */
/********************************************************/

function layerslider_check_unit($str) {

	if(strstr($str, 'px') == false && strstr($str, '%') == false) {
		return $str.'px';
	} else {
		return $str;
	}
}

function layerslider_convert_urls($arr) {

	// Iterate over the array and remove basehref from URLs
	foreach($arr['layers'] as $layerkey => $layer) {

		// Layer background
		if(strpos($layer['properties']['background'], 'http://') !== false) {

		    $arr['layers'][$layerkey]['properties']['background'] = parse_url($layer['properties']['background'], PHP_URL_PATH);
		}

		// Image sublayers
		foreach($layer['sublayers'] as $sublayerkey => $sublayer) {

		    if($sublayer['type'] == 'img') {
		    	if(strpos($sublayer['image'], 'http://') !== false) {
		    		$arr['layers'][$layerkey]['sublayers'][$sublayerkey]['image'] = parse_url($sublayer['image'], PHP_URL_PATH);
		    	}
		    }
		}
	}

	return $arr;
}

/********************************************************/
/*                   Widget settings                    */
/********************************************************/

class LayerSlider_Widget extends WP_Widget {

	function LayerSlider_Widget() {

		$widget_ops = array( 'classname' => 'layerslider_widget', 'description' => __('Insert a slider with LayerSlider WP Widget', 'layerslider') );
		$control_ops = array( 'id_base' => 'layerslider_widget' );
		$this->WP_Widget( 'layerslider_widget', __('LayerSlider WP Widget', 'layerslider'), $widget_ops, $control_ops );
	}

	function widget( $args, $instance ) {
		extract( $args );

		$title = apply_filters('widget_title', $instance['title'] );


		echo $before_widget;

		if ( $title )
			echo $before_title . $title . $after_title;

		// Call layerslider_init to show the slider
		echo do_shortcode('[layerslider id="'.$instance['id'].'"]');

		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		/* Strip tags for title and name to remove HTML (important for text inputs). */
		$instance['id'] = strip_tags( $new_instance['id'] );
		$instance['title'] = strip_tags( $new_instance['title'] );
		return $instance;
	}

	function form( $instance ) {

		$defaults = array( 'title' => __('LayerSlider', 'layerslider'));
		$instance = wp_parse_args( (array) $instance, $defaults );
		$slides = get_option('layerslider-slides');
		$slides = is_array($slides) ? $slides : unserialize($slides);
		?>

		<p>
			<label for="<?php echo $this->get_field_id( 'id' ); ?>">Choose a slider:</label><br>
			<select id="<?php echo $this->get_field_id( 'id' ); ?>" name="<?php echo $this->get_field_name( 'id' ); ?>">
				<?php foreach($slides as $key => $val) : ?>
				<?php $name = empty($val['properties']['title']) ? 'Unnamed' : $val['properties']['title']; ?>
				<?php if(($key+1) == $instance['id']) { ?>
				<option value="<?php echo $key+1?>" selected="selected"><?php echo $name ?> | #<?php echo $key+1?></option>
				<?php } else { ?>
				<option value="<?php echo $key+1?>"><?php echo $name ?> | #<?php echo $key+1?></option>
				<?php } ?>
				<?php endforeach; ?>
			</select>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'hybrid'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" class="widefat" />
		</p>


	<?php
	}
}